<?php

include('includes/global.php');

function WriteTranslatNames($Text,$mode) 
{
  $Output = '';
  if ($mode == 0) $Output .= '..Nalezené názvy jmen věcí, míst, postav';
  if ($mode == 1) $Output .= '..Všechny přeložené';
  if ($mode == 2) $Output .= '..Nepřeložené';
  $Output .= '<table width="98%" class="BaseTable">';
  $Output .= '<tr><th>Originál</th>'.'<th>Překlad</th></tr>';

  $TablesColumn = array
  (
    'TextGameObject' => 'Name',
    'TextCreature' => 'name',
    'TextItem' => 'Name',
    'TextTransport' => 'Name',
    'TextAreaTriggerTeleport' => 'Name',
    'TextAreaTriggerTavern' => 'Name',
    'Dictionary' => 'Text',
  );

  $buff = GetTranslatNames($Text,$mode,$TablesColumn);
  
   // $buff[] = array($Line['ID'],GetIDbyName($Table),$Line[$Column],$Line['Tran']);
  foreach($buff as $Line) {
      if ($mode == 0) 
      {
        if (strpos(strtolower($Text), strtolower($Line[2])) > 0) 
        {
          $Output .= '<tr><td>'.$Line[2].'</td>';
          if ($Line[3] <> '') $Output .= '<td><a target="_NEW2" href="form.php?group='.$Line[1].'&amp;ID='.$Line[0].'">'.$Line[3].'</a></td></tr>';
          else $Output .= '<td><a target="_NEW2" href="form.php?group='.$Line[1].'&amp;ID='.$Line[0].'">Překládat</a></td></tr>';
        }
      } else 
      {
        $Output .= '<tr><td>'.$Line[2].'</td>';
          if ($Line[3] <> '') $Output .= '<td><a target="_NEW2" href="form.php?group='.$Line[1].'&amp;ID='.$Line[0].'">'.$Line[3].'</a></td></tr>';
          else $Output .= '<td><a target="_NEW2" href="form.php?group='.$Line[1].'&amp;ID='.$Line[0].'">Překládat</a></td></tr>';
      }
  }
  $Output .= '</table>';
  return($Output);
}

$LanguageList = GetLanguageList();

if(!isset($_SESSION['language']))
{
	if($User->Licence(LICENCE_USER))
	{
 		$_SESSION['language'] = $User->Language;
  } else $_SESSION['language'] = '';
}
if(array_key_exists('language', $_GET)) {
  if($_GET['language'] == '') $_SESSION['language'] = '';
	  else $_SESSION['language'] = $_GET['language'] * 1;
}

$Output = '<h3>Slovníček</h3>';

function DictionaryInsert()
{
  global $System, $User;
  
  $Output = '';
  if($User->Licence(LICENCE_USER))
  {
    $Output .= '<form action="dictionary.php?action=save" method="post">'.
        '<fieldset><legend>Vložení nového slova</legend>'.
        '<table><tr><td>'.
        'Původní anglické slovo:</td><td><input type="text" name="Original" /></td></tr>'.
        '<tr><td>Přeložené:</td><td><input type="text" name="Translated" /></td></tr>'.
        '<tr><td>Jazyk:</td><td>'.WriteLanguages($_SESSION['language']).'</td></tr>'.
        '<tr><td>Volitelný popis:</td><td><input type="text" name="Description" /></td></tr>'.
        '<tr><td colspan="2"><input type="submit" value="Uložit" /></td></tr>'.
        '</td></tr></table>'.
        '</fieldset>'.
        '</form>';
  } else $Output .= ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
  return($Output); 
}

function DictionarySave()
{
  global $System, $User, $Config;
  
  if($User->Licence(LICENCE_USER))
  {
    if(array_key_exists('Original', $_POST) and array_key_exists('Translated', $_POST) and array_key_exists('Description', $_POST))
    {
      // Check if original text exists and determine entry id
      $DbResult = $System->Database->query('SELECT * FROM `Dictionary` WHERE '.
        '`Text` = "'.$_POST['Original'].'" AND `Language`= '.$Config['OriginalLanguage']);
      if($DbResult->num_rows > 0)
      {
        $DbRow = $DbResult->fetch_assoc();
        $Entry = $DbRow['Entry'];
      } else
      {
        $DbResult = $System->Database->query('SELECT MAX(`Entry`) FROM `Dictionary`');
        $DbRow = $DbResult->fetch_row();
        $Entry = $DbRow[0] + 1;
        $System->Database->query('INSERT INTO `Dictionary` ( `Text` , `Entry` , `Description` , '.
          '`User`, `Language` ) VALUES ("'.$_POST['Original'].'", "'.$Entry.'", "", NULL, '.$Config['OriginalLanguage'].');');
      }
  
      $DbResult = $System->Database->query('SELECT `Id` FROM `Dictionary` WHERE '.
        '`Entry` = '.$Entry.' AND `Language`='.$_POST['Language'].' AND `User`='.$User->Id);
      if($DbResult->num_rows > 0)
      {
        $DbRow = $DbResult->fetch_assoc();
        $System->Database->query('UPDATE `Dictionary` SET `Text`="'.$_POST['Translated'].'", '.
          '`Description` = "'.$_POST['Description'].'" WHERE Id='.$DbRow['Id']);
      } else
        $System->Database->query('INSERT INTO `Dictionary` ( `Text` , `Entry` , `Description` , '.
          '`User`, `Language` ) VALUES ("'.$_POST['Translated'].'", "'.$Entry.'", "'.$_POST['Description'].'", '.$User->Id.', '.$_POST['Language'].')');
      $Output = ShowMessage('Záznam byl uložen!');
    } else $Output = ShowMessage('Nebyly zaslány všechny položky formuláře.', MESSAGE_CRITICAL);
  } else $Output = ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
  return($Output); 
}

function DictionaryRemove()
{
  global $System, $User;
  
  if($User->Licence(LICENCE_USER))
  {
    $System->Database->query('DELETE FROM `Dictionary` WHERE (`User`='.$User->Id.') AND (`Id`='.($_GET['id'] * 1).')');
    $Output = ShowMessage('Záznam odstraněn.');
  } else $Output = ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
  return($Output);
}

function DictionaryModify()
{
  global $System, $User, $Config;
  
  if($User->Licence(LICENCE_USER))
  {
    $DbResult = $System->Database->query('SELECT * FROM `Dictionary` WHERE `Id`='.($_GET['id'] * 1));
    if($DbResult->num_rows > 0)
    {
      $DbRow = $DbResult->fetch_assoc();
      $DbResult = $System->Database->query('SELECT * FROM `Dictionary` WHERE (`User` IS NULL) '.
        'AND (`Entry`='.$DbRow['Entry'].') AND (`Language`= '.$Config['OriginalLanguage'].')');
      $DbRow2 = $DbResult->fetch_assoc();
      $Output = '<form action="dictionary.php?action=save" method="post">'.
        '<fieldset><legend>Upravení slova</legend>'.
        '<input type="hidden" name="id"  value="'.$_GET['id'].'"/>'.
        '<table><tr><td>'.
        'Původní anglické slovo:</td><td><input type="text" name="Original" value="'.$DbRow2['Text'].'" /></td></tr>'.
        '<tr><td>Přeložené:</td><td><input type="text" name="Translated"  value="'.$DbRow['Text'].'" /></td></tr>'.
        '<tr><td>Jazyk:</td><td>'.WriteLanguages($DbRow['Language']).'</td></tr>'.
        '<tr><td>Popis:</td><td><input type="text" name="Description"  value="'.$DbRow['Description'].'" /></td></tr>'.
        '<tr><td colspan="2"><input type="submit" value="Uložit" /></td></tr>'.
        '</td></tr></table>'.
        '</fieldset>'.
        '</form>';
    } else $Output = ShowMessage('Položka nenalezena', MESSAGE_CRITICAL); 
  } else $Output = ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
  return($Output);
}

function DictionaryGroup()
{
  global $System, $User, $TranslationTree;
  
  $Output = '';
  $GroupId = LoadGroupIdParameter();
  if(array_key_exists('mode', $_GET)) $mode = $_GET['mode'];
  else $mode = 0; //0 = exact names, 1=all names, 2=nontranslated
  $Table = $TranslationTree[$GroupId]['TablePrefix'];
  
  if(array_key_exists('ID', $_GET))
  {
    $TextID = $_GET['ID'];
    $Output .= 'Přeložené názvy vztahující se k překladu: <a target="_NEW" href="form.php?group='.$GroupId.'&amp;ID='.$TextID.'">'.$TextID.'</a><br />'.
        '<a href="?action=group&amp;mode=1&amp;group='.$GroupId.'&amp;ID='.$TextID.'" title="Zobrazit všechny podobné výsledky">Všechny</a> '.
        '<a href="?action=group&amp;mode=0&amp;group='.$GroupId.'&amp;ID='.$TextID.'" title="Zobrazit pouze přesné výsledky">Přesné</a> '.
        '<a href="?action=group&amp;mode=2&amp;group='.$GroupId.'&amp;ID='.$TextID.'" title="Zobrazit všechny nepřeložené">Nepřeložené</a> ';
    $DbResult = $System->Database->query('SELECT * FROM '.$Table.' WHERE ID = '.$TextID);
    $Line = $DbResult->fetch_assoc();
    if(!$Line) $Output .= ShowMessage('Překlad nenalezen.', MESSAGE_CRITICAL);
    else
    {
      $Text = '';
      foreach($TranslationTree[$GroupId]['Items'] as $Index => $TextItem)
        $Text .= ' '.$Line[$TextItem['Column']];
      $Output .= WriteTranslatNames($Text, $mode);
    }
  }  
  return($Output);
}

function DictionaryShow()
{
  global $System, $User, $LanguageList, $Config;
  
  $Output = '<form action="dictionary.php" method="get" style="margin: 0px; padding: 0px;">'.
  '<table style="width: 100%; height: 100%;">';

  if(array_key_exists('search', $_GET)) $Search = $_GET['search'];
    else $Search = '';
       
  $Output .= '<tr><td>
    <input type="text" value="'.$Search.'" name="search" size="30" />
    <input type="submit" value="Vyhledat" />';
  if($User->Licence(LICENCE_USER)) $Output .= ' <a href="dictionary.php?action=insert">Vložit slovo</a>';
           
  $Output .= '</td></tr>'. 
    '<tr><td>Jazyk: ';
  $Lang = '<a href="?language=">Všechny</a>';
  if($_SESSION['language'] == '') $Output .= '<strong>'.$Lang.'</strong> ';
    else $Output .= $Lang;
  foreach($LanguageList as $Language)
    if($Language['Enabled'] == 1)
    {
    	$Lang = ' <a href="?language='.$Language['Id'].'">'.$Language['Name'].'</a>';
      if($Language['Id'] == $_SESSION['language']) $Output .= '<strong>'.$Lang.'</strong> ';
        else $Output .= $Lang;
    }
  $Output .= '</td></tr>'.
    '<tr><td>';
  //<div style="overflow: auto; width: 100%; height: 100%;">');

  if(!is_numeric($_SESSION['language'])) $LanguageFilter = '';
    else $LanguageFilter = ' AND (`T1`.`Language` = '.$_SESSION['language'].')';

  if($Search <> '') 
  {
    $Condition = ' AND (LOWER(`T1`.`Text`) LIKE LOWER("%'.$Search.'%")) OR '.
      '(LOWER(`T1`.`Description`) LIKE LOWER("%'.$Search.'%"))';
  } else $Condition = ''; 
  $sql = 'SELECT `User`.`Name` AS `UserName`, `User`.`Id` AS `UserId`, '.
      '`Language`.`Name` AS `LangName`, `T1`.`Id` AS `Id`, '.
      '`T1`.`Entry`, `T2`.`Text` AS `Original`, `T1`.`Text` AS `Translated`, `T1`.`Description` '.    
      'FROM `Dictionary` AS `T1` JOIN `Dictionary` AS `T2` '.
      'ON (`T2`.`Entry` = `T1`.`Entry`) AND (`T2`.`Language` = '.$Config['OriginalLanguage'].') '.
      'JOIN `Language` ON `Language`.`Id` = `T1`.`Language` '.
      'JOIN `User` ON `User`.`ID` = `T1`.`User` '.
      'WHERE 1'.
      $LanguageFilter.$Condition;
  
  $DbResult = $System->Database->query('SELECT COUNT(*) FROM ('.$sql.') AS `T1`');
  $DbRow = $DbResult->fetch_row();
  $PageList = GetPageList($DbRow[0]);  

  $Output .= $PageList['Output'];
  
  if(is_numeric($_SESSION['language'])) $LanguageName = $LanguageList[$_SESSION['language']]['Name'];
    else $LanguageName = 'Překlad';
  $TableColumns = array(      
    array('Name' => 'Original', 'Title' => 'Angličtina'), 
    array('Name' => 'Translated', 'Title' => $LanguageName),
  ); 
  if(!is_numeric($_SESSION['language'])) $TableColumns[] = array('Name' => 'LangName', 'Title' => 'Jazyk');
  $TableColumns[] = array('Name' => 'Description', 'Title' => 'Popis');
  $TableColumns[] = array('Name' => 'UserName', 'Title' => 'Překladatel');   
  if($User->Licence(LICENCE_USER)) $TableColumns[] = array('Name' => '', 'Title' => 'Akce');
  $Order = GetOrderTableHeader($TableColumns, 'Original');
  $Output .= '<table width="98%" class="BaseTable">'.$Order['Output'];

  $sql_page = $sql.$Order['SQL'].$PageList['SQLLimit'];
  $DbResult = $System->Database->query($sql_page);
  while($Line = $DbResult->fetch_assoc()) 
  {
    $Output .= '<tr>'.
    '<td>'.$Line['Original'].'</td>'.
    '<td><strong>'.$Line['Translated'].'</strong></td>';
    if(!is_numeric($_SESSION['language'])) $Output .= '<td>'.$Line['LangName'].'</td>';
    $Output .= '<td>'.$Line['Description'].'</td>'.
    '<td><a href="user.php?user='.$Line['UserId'].'">'.$Line['UserName'].'</a></td>';
    if($User->Licence(LICENCE_USER))
    {
      if($Line['UserId'] == $User->Id) 
        $Output .= '<td><a href="?action=remove&amp;id='.$Line['Id'].'" onclick="return confirmAction(\'Opravdu smazat položku?\');">Smazat</a>'.
        ' <a href="?action=modify&amp;id='.$Line['Id'].'">Upravit</a></td>';
        else $Output .= '<td></td>';
    }
    $Output .= '</tr>';
  }
  $Output .= '</table>'.  
    $PageList['Output'].
    '</td></tr>'. 
    '</table></form>';
  return($Output);
}

$Output = '';
$ShowList = true;
if(array_key_exists('action', $_GET)) 
{
  if($_GET['action'] == 'group') {
    $Output .= DictionaryGroup();
    $ShowList = false;
  }
  else if($_GET['action'] == 'insert') $Output .= DictionaryInsert(); 
  else if($_GET['action'] == 'save') $Output .= DictionarySave(); 
  else if($_GET['action'] == 'remove') $Output .= DictionaryRemove();
  else if($_GET['action'] == 'modify') $Output .= DictionaryModify();
  else $Output .= ShowMessage('Neznámá akce', MESSAGE_CRITICAL);  
} 
if($ShowList == true) $Output .= DictionaryShow();

ShowPage($Output);

?>
